#include "chare.h"
#include "machine.h"
#include "extern.h"

/*#define ROUTE */
#define MSGPASSING

OsKillMyself()
{
    int	  peNum = McMyPeNum();

    CHARESTAT(PE(peNum).myChareBlk)= CHARETYPE_KILL;
    PE(peNum).currentChare--;
}

OsMyPeNum()
{
    return(McMyPeNum());
}

CHAREBLK *OsMyChNum()
{
    int	  peNum = McMyPeNum();

    return(PE(peNum).myChareBlk);
}

OsMyLoad()
{
    int	  peNum = McMyPeNum();

    return(PE(peNum).newLoad);
}
OsMyLoad2()
{
    int	  peNum = McMyPeNum(),i,k,leastLoad;


    leastLoad = PE(peNum).newLoad; 
    for (i = 1; i <= PE(peNum).neighborNum; i++) {
        if (PE(peNum).loadAry[k=PE(peNum).neighbors[i]] < leastLoad) {
	    leastLoad = PE(peNum).loadAry[k];
	    }
	}
    return(leastLoad);
}

MyChareID(ptr)
ChareIDType *ptr;
{
    ptr->pe = McMyPeNum();
    ptr->ch = (int) PE(ptr->pe).myChareBlk;
}
OsCopyChareID(p1,p2)
ChareIDType *p1,*p2;
{
    p1->pe = p2->pe;
    p1->ch = p2->ch;
}
ChareIDType *ParentChareID()
{
    return(CHAREPID(PE(peNum).myChareBlk));
}

OsKillSys()
{
    McKillSys();
}

OsGetSysClk()
{
    return(McGetSysClk(McMyPeNum()));
}


SYSMSG *OsNextWork(codeP,dataPP,msgPP)
USRMSG **msgPP;
int **dataPP;
int *codeP;
{
    int	     i,j,k,n,peNum=McMyPeNum(),*infPtr;
    SYSMSG   *mPtr,*sPtr,*newPtr,*CreateSysMsg(),*QmGetUsrMsg(),*QmDeQueue();
    CHAREBLK *CreateChareBlk(), *cPtr, *vPtr;
#ifdef HASH
    HASHBLK  *hPtr = NULLPTR, *HashHandle();
#endif
    PECHCELL *matchPtr;

    clock_off();

    if (PE(peNum).waitQ.head != NULLPTR) {
	mPtr = QmDeQueue(&PE(peNum).waitQ);
	}
    else {
        mPtr = QmGetUsrMsg(peNum); 
	}
#ifdef TERMINATION
    /* set busy swtich to TRUE */
    PE(peNum).everBusy = TRUE;
#endif
#ifdef QUIET
    /* set busy swtich to TRUE */
    PE(peNum).everBusy = TRUE;
#endif
    
#ifdef HASH
    if (SYSMSGTYPE(mPtr) == SYSMSGTYPE_HASH) {
	hPtr = HashHandle(mPtr,peNum,SYSMSGDESTCH(mPtr));
	if (hPtr == NULLPTR) {
            return(NULLPTR);
	    }
	else {
	    SYSMSGTYPE(mPtr) = SYSMSGTYPE_CHAR;
	    }
	}
#endif
    if (SYSMSGTYPE(mPtr) == SYSMSGTYPE_CHAR) {
	/* keep network,os information here */
	PE(peNum).myChareBlk = cPtr = CreateChareBlk(SYSMSGSRCPE(mPtr),
				SYSMSGSRCCH(mPtr),CHARETYPE_IDLE,
				SYSMSGUCDS(mPtr),SYSMSGDESTCH(mPtr));
#ifdef HASH
	PE(peNum).myChareBlk->hPtr = hPtr;
#endif
	PE(peNum).currentChare++;
	QmEnChQ(PE(peNum).myChareBlk,&PE(peNum).allChareQ);
	*dataPP		= CHARECDPTR(PE(peNum).myChareBlk);
#ifdef ORACLESIM
	for (i=0; i <= MAXHOPS; i++) {
	    CHARESYSDATA(PE(peNum).myChareBlk,i) = SYSMSGPATH(mPtr,i);
	    } 
 	CHARESYSDATA(PE(peNum).myChareBlk,0) = SYSMSGHOPS(mPtr);
    	/* record information about # of hops taken for goal msg */
    	if (SYSMSGHOPS(mPtr) >= MAXHOPS) 
    	    op.hopsTaken[MAXHOPS] += 1; 
        else
    	    op.hopsTaken[SYSMSGHOPS(mPtr)] += 1; 
#endif
	op.hopsNum += SYSMSGHOPS(mPtr);
	PE(peNum).chareNumConsumed++;
/*	if (SYSMSGSRCPE(mPtr) != peNum) PE(peNum).chareNumRemote++;*/
	if (SYSMSGHOPS(mPtr) > 0) PE(peNum).chareNumRemote++;
	if ((vPtr=SYSMSGVIRTUALBLK(mPtr)) != NULLPTR) {
	    if (SYSMSGSRCPE(mPtr) != peNum) {
	        newPtr = CreateSysMsg(SYSMSGTYPE_PECH,0,NULLPTR,
				peNum,PE(peNum).myChareBlk,
				SYSMSGSRCPE(mPtr),SYSMSGSRCCH(mPtr),
				SYSMSGSRCPE(mPtr),
				FALSE,sizeof(SYSMSG),0,0,vPtr,NULLPTR,0);
	        McSendMsg(newPtr,peNum);
		}
	    else {
		CHAREIDPE((CHARERID(vPtr))) = peNum;
		CHAREIDCH((CHARERID(vPtr))) = (int) PE(peNum).myChareBlk;
		CHARESTAT(vPtr) = CHARETYPE_VIR1;
		while (vPtr->pendingMsg.head != NULLPTR) {
		    newPtr = (SYSMSG*)QmDeQueue(&vPtr->pendingMsg);
		    SYSMSGDESTPE(newPtr) = SYSMSGNEXTPE(newPtr) = peNum;
		    SYSMSGDESTCH(newPtr) = PE(peNum).myChareBlk;
		    QmPutLocalMsg(newPtr,peNum);
		    }
		}
	    }
	/* SPREAD check if any spread message is for this new chare */
	for (sPtr = (SYSMSG*) PE(peNum).spreadQ.head; 
		sPtr != NULLPTR; sPtr = SYSMSGNEXTPTR(sPtr)) {
	    if (MatchLogicID(SYSMSGDESTCH(sPtr),CHARELOGICID(cPtr))) {
	        DuplicateMsg(&newPtr,sPtr);
	        SYSMSGDESTPE(newPtr) = peNum;
	        SYSMSGDESTCH(newPtr) = cPtr;
	        QmEnQueue(newPtr,&PE(peNum).waitQ,SYSMSGUPRIO(newPtr));
		}
	    }
	}
    else if (SYSMSGDESTPE(mPtr) == peNum) {
 	PE(peNum).myChareBlk 	= SYSMSGDESTCH(mPtr);
	*dataPP 	= CHARECDPTR(PE(peNum).myChareBlk);  
	PE(peNum).dataNumConsumed++;
	}
    else { /* SPREAD handle spread messages */
	for (i = k = 0, cPtr = (CHAREBLK*) PE(peNum).allChareQ.head; 
		cPtr != NULLPTR; cPtr = CHARERPTR(cPtr), i++) 
	    if ((SYSMSGSRCPE(mPtr) != peNum || SYSMSGSRCCH(mPtr) != cPtr)
		    && MatchLogicID(SYSMSGDESTCH(mPtr),CHARELOGICID(cPtr))) {
		if (k == 0) {
 		    PE(peNum).myChareBlk = cPtr;
		    *dataPP 		 = CHARECDPTR(PE(peNum).myChareBlk);  
		    PE(peNum).dataNumConsumed++;
		    k++;
		    }
		else {
		    DuplicateMsg(&newPtr,mPtr);
		    SYSMSGDESTPE(newPtr) = peNum;
		    SYSMSGDESTCH(newPtr) = cPtr;
		    QmEnQueue(newPtr,&PE(peNum).waitQ,SYSMSGUPRIO(newPtr));
		    k++;
		    }
		}
	      if (k == 0) {/* no chare getting this message */
		  QmEnQueue(mPtr,&PE(peNum).spreadQ,SYSMSGUPRIO(mPtr));
		  mPtr = NULLPTR;
		  }
	      else {
		  DuplicateMsg(&newPtr,mPtr);
		  QmEnQueue(newPtr,&PE(peNum).spreadQ,SYSMSGUPRIO(newPtr));
		  }
	    }

    if (mPtr != NULLPTR) {
	McSeparateMsg(mPtr);
        /* extract real message for interpreter */
        *codeP = SYSMSGUCODE(mPtr);
        *msgPP = (USRMSG *) SYSMSGUPTR(mPtr);
	}

    fflush(stdout);
    co_time_on(k);
    return(mPtr);
}

/*
void OsFirstChare(msgCode,ptrUsrMsg,msgSize,msgPrio,msgPack,msgCDsize)
USRMSG *ptrUsrMsg;
int    msgCode;
int    msgSize;
int    msgPrio;
int    msgPack;
int    msgCDsize;
{
OsFirstChare1(msgCode,ptrUsrMsg,msgSize,msgPrio,msgPack,msgCDsize,
		STARTSRCPE,STARTDESTPE);
}
*/
OsFirstChare(msgCode,ptrUsrMsg,msgSize,msgPrio,msgPack,msgCDsize,
		idPtr,destPE,logicID)
USRMSG *ptrUsrMsg;
int    msgCode;
int    msgSize;
int    msgPrio;
int    msgPack;
int    msgCDsize;
ChareIDType *idPtr;
int    destPE;
int    logicID;
{
    int		i,k,peNum=OsMyPeNum();
    SYSMSG	*mPtr, *ExtendSysMsg(),*CreateSysMsg();
    CHAREBLK	*cPtr, *CreateChareBlk();

    cPtr = PE(peNum).myChareBlk;
    mPtr = ExtendSysMsg(SYSMSGTYPE_CHAR,msgCode,ptrUsrMsg,
			peNum,cPtr,destPE,logicID,destPE,
			msgPack,msgSize+sizeof(SYSMSG),msgSize,msgCDsize,
			NULLPTR,NULLPTR,msgPrio);
    LdbFirstChare(mPtr);
}

OsCreateChare(msgCode,ptrUsrMsg,msgSize,msgPrio,msgPack,msgCDsize,
		idPtr,destPE,logicID)
USRMSG *ptrUsrMsg;
int    msgCode;
int    msgSize;
int    msgPrio;
int    msgPack;
int    msgCDsize;
ChareIDType *idPtr;
int    destPE;
int    logicID;
{
    int		i,k,peNum=McMyPeNum();
    SYSMSG	*mPtr, *CreateSysMsg(), *ExtendSysMsg();
    CHAREBLK 	*CreateVirtualBlk(), *vPtr;

    PE(peNum).chareNumGenerated++;

    if (idPtr != NULLPTR) {
	vPtr = CreateVirtualBlk();
	CHAREIDPE(idPtr) = peNum;
	CHAREIDCH(idPtr) = (int) vPtr;
	}
    else vPtr = NULLPTR;
	
    mPtr = ExtendSysMsg(SYSMSGTYPE_CHAR,msgCode,ptrUsrMsg,
			peNum,PE(peNum).myChareBlk,-1,logicID,-1,
			msgPack,msgSize+sizeof(SYSMSG),msgSize,msgCDsize,
			vPtr,NULLPTR,msgPrio);
#ifdef SHAREDMEM
	SYSMSGNEXTPE(mPtr) = SYSMSGDESTPE(mPtr) = peNum;
	McSendMsg(mPtr,peNum);
#else
    if (destPE == DUMMY)
        LdbNewChare(mPtr);
    else {
	SYSMSGNEXTPE(mPtr) = SYSMSGDESTPE(mPtr) = destPE;
   	if (destPE == peNum)
	    QmPutLocalMsg(mPtr,peNum);
	else
	    McSendMsg(mPtr,peNum);
	}
#endif
}

#ifdef HASH
OsHashChare(msgCode,ptrUsrMsg,msgSize,msgPrio,msgPack,msgCDsize,
		idPtr,destPE,logicID)
USRMSG *ptrUsrMsg;
int    msgCode;
int    msgSize;
int    msgPrio;
int    msgPack;
int    msgCDsize;
ChareIDType *idPtr;
int    destPE;
int    logicID;
{
    int		i,k,peNum=McMyPeNum();
    SYSMSG	*mPtr, *CreateSysMsg(), *ExtendSysMsg();
    CHAREBLK 	*CreateVirtualBlk(), *vPtr;

    PE(peNum).chareNumGenerated++;

    if (idPtr != NULLPTR) {
	vPtr = CreateVirtualBlk();
	CHAREIDPE(idPtr) = peNum;
	CHAREIDCH(idPtr) = (int) vPtr;
	}
    else vPtr = NULLPTR;
	
    destPE = OsHashPE(logicID);
    mPtr = ExtendSysMsg(SYSMSGTYPE_HASH,msgCode,ptrUsrMsg,
			peNum,PE(peNum).myChareBlk,destPE,logicID,destPE,
			msgPack,msgSize+sizeof(SYSMSG),msgSize,msgCDsize,
			vPtr,NULLPTR,msgPrio);
   	if (destPE == peNum)
	    QmPutLocalMsg(mPtr,peNum);
	else
	    McSendMsg(mPtr,peNum);
}
OsHashPE(x)
int x;
{
    return(x % CubeNodeNum());
}
HASHBLK *HashHandle(mPtr,peNum,x)
SYSMSG *mPtr;
int    x,peNum;
{   int i,k;
    SYSMSG *rPtr,*newPtr;

    for (i = 0; i < PE(peNum).hNext; i++) {
	if (PE(peNum).hBlk[i].hashNum == x) {
	    k = PE(peNum).hBlk[i].sharedNext++;
	    CHAREIDPE((&PE(peNum).hBlk[i].sharedID[k])) = SYSMSGSRCPE(mPtr);
	    CHAREIDCH((&PE(peNum).hBlk[i].sharedID[k])) = (int) SYSMSGSRCCH(mPtr);
	    for (rPtr = (SYSMSG*) PE(peNum).hBlk[i].resultQ.head; 
		rPtr != NULLPTR; rPtr = SYSMSGNEXTPTR(rPtr)) {
	        DuplicateMsg(&newPtr,rPtr);
	        SYSMSGNEXTPE(newPtr) = SYSMSGDESTPE(newPtr) = SYSMSGSRCPE(mPtr);;
	        SYSMSGDESTCH(newPtr) = SYSMSGSRCCH(mPtr);;
    		if (peNum == SYSMSGSRCPE(mPtr)) {
		    SYSMSGNEEDPACK(newPtr) = FALSE;
      		    QmPutLocalMsg(newPtr,peNum);
      		    }
    	   	else {
     		    McSendMsg(newPtr,peNum);
     		    }
		}
	    OsFree(mPtr,SYSMSGSIZE(mPtr));
	    return(NULLPTR);
	    }
	}
    k = PE(peNum).hNext++;
    if (k >= MAXENTRY) {
	printf("Too Large index\n");
	OsKillSys();
	}
    PE(peNum).hBlk[k].sharedNext++;
    CHAREIDPE((&PE(peNum).hBlk[k].sharedID[0])) = SYSMSGSRCPE(mPtr);
    CHAREIDCH((&PE(peNum).hBlk[k].sharedID[0])) = (int) SYSMSGSRCCH(mPtr);
    PE(peNum).hBlk[k].hashNum = x;
    return(&PE(peNum).hBlk[k]); 
}
OsSendResult(msgCode,ptrUsrMsg,msgSize,msgPrio,msgPack,destPtr)
USRMSG *ptrUsrMsg;
int    msgCode;
int    msgSize;
int    msgPrio;
int    msgPack;
ChareIDType    *destPtr;
{
    int		i,k;
    SYSMSG	*mPtr, *ExtendSysMsg(),*CreateSysMsg();
    int		destPE=CHAREIDPE(destPtr);
    CHAREBLK	*destCB=(CHAREBLK*) CHAREIDCH(destPtr);
    int 	peNum=McMyPeNum(),nextNum=destPE,distNum=0,*ptrPath=0;

    PE(peNum).dataNumGenerated++;

    mPtr = ExtendSysMsg(SYSMSGTYPE_DATA,msgCode,ptrUsrMsg,
			peNum,PE(peNum).myChareBlk,destPE,destCB,destPE,
			msgPack,sizeof(SYSMSG)+msgSize,msgSize,0,NULLPTR,
			NULLPTR,msgPrio);
    ResultHandle(mPtr,PE(peNum).myChareBlk->hPtr,peNum);
    if (peNum == destPE) {
	SYSMSGNEEDPACK(mPtr) = FALSE;
      	QmPutLocalMsg(mPtr,peNum);
      	}
    else {
     	if (distNum > 1) SYSMSGHOPS(mPtr) -= 1;
     	McSendMsg(mPtr,peNum);
     	}
}
ResultHandle(mPtr,hPtr,peNum)
SYSMSG  *mPtr;
HASHBLK *hPtr;
{  int i,destPE,destCB;
   SYSMSG *newPtr;

   for (i = 1; i < hPtr->sharedNext; i++) {
	DuplicateMsg(&newPtr,mPtr);
	destPE = SYSMSGDESTPE(newPtr) = SYSMSGNEXTPE(newPtr) 
			= CHAREIDPE((&hPtr->sharedID[i]));
	destCB = CHAREIDCH((&hPtr->sharedID[i]));
	SYSMSGDESTCH(newPtr) = (CHAREBLK*) destCB;
        if (peNum == destPE) {
	    SYSMSGNEEDPACK(newPtr) = FALSE;
	    SYSMSGNEEDPACK(newPtr) = FALSE;
      	    QmPutLocalMsg(newPtr,peNum);
      	    }
        else {
     	    McSendMsg(newPtr,peNum);
     	    }
	}
    DuplicateMsg(&newPtr,mPtr);
    QmEnQueue(newPtr,&hPtr->resultQ,SYSMSGUPRIO(newPtr));
}
#endif

OsSendMsg(msgCode,ptrUsrMsg,msgSize,msgPrio,msgPack,destPtr)
USRMSG *ptrUsrMsg;
int    msgCode;
int    msgSize;
int    msgPrio;
int    msgPack;
ChareIDType    *destPtr;
{
    int		i,k,busNum=0;
    SYSMSG	*mPtr, *ExtendSysMsg(),*CreateSysMsg();
    int		destPE=CHAREIDPE(destPtr);
    CHAREBLK	*destCB=(CHAREBLK*) CHAREIDCH(destPtr);
    int 	peNum=McMyPeNum(),nextNum=destPE,distNum=0,*ptrPath=0;

    PE(peNum).dataNumGenerated++;

    if (peNum == destPE && CHARESTAT(destCB) == CHARETYPE_VIR1) {
	    destPE = CHAREIDPE((CHARERID(destCB)));
	    destCB = (CHAREBLK*) CHAREIDCH((CHARERID(destCB)));
	    }
    if (peNum == destPE) {
      	mPtr = ExtendSysMsg(SYSMSGTYPE_DATA,msgCode,ptrUsrMsg,
			peNum,PE(peNum).myChareBlk,destPE,destCB,peNum,
			FALSE,sizeof(SYSMSG)+msgSize,msgSize,0,NULLPTR,
			NULLPTR,msgPrio);
      	if (CHARESTAT(destCB) == CHARETYPE_VIR0) {
      	    InsertL(&((CHAREBLK*)destCB)->pendingMsg,mPtr);
	    }
      	else QmPutLocalMsg(mPtr,peNum);
      	}
    else {
    	mPtr = ExtendSysMsg(SYSMSGTYPE_DATA,msgCode,ptrUsrMsg,
			peNum,PE(peNum).myChareBlk,destPE,destCB,nextNum,
			msgPack,msgSize+sizeof(SYSMSG),msgSize,0,
			NULLPTR,ptrPath,msgPrio);
     	if (distNum > 1) SYSMSGHOPS(mPtr) -= 1;
     	McSendMsg(mPtr,peNum,busNum);
     	}

    /*CoMsgNoWait(peNum);  turn on when CWN applied 
    if (ip.CS == CSGRANDDIFF) {
	CoGranDiff(peNum);     
	} */

}

OsSendMsgAll(msgCode,ptrUsrMsg,msgSize,msgPrio,msgPack,destNum)
USRMSG *ptrUsrMsg;
int    msgCode;
int    msgSize;
int    msgPrio;
int    msgPack;
int    destNum;
/*PECHCELL *destAry;*/
{
    int		i,k,busNum=0;
    SYSMSG	*mPtr, *ExtendSysMsg(),*CreateSysMsg();
    int 	peNum=McMyPeNum(),distNum=0,*ptrPath=0;
    char	*p1, *p2;
    USRMSG	*newUsrMsg;

    PE(peNum).dataNumGenerated++;

    mPtr = ExtendSysMsg(SYSMSGTYPE_DATA,msgCode,ptrUsrMsg,
			peNum,PE(peNum).myChareBlk,ALLNODES,destNum,ALLNODES,
			msgPack,msgSize+sizeof(SYSMSG),msgSize,0,NULLPTR,
			NULLPTR,msgPrio);
    McSendMsg(mPtr,peNum);
}

Loop(peNum)
int peNum;
{
    SYSMSG *m,*OsNextWork();
    USRMSG *usrPtr;
    int    i,code,*dataP;

    McInitClk(peNum); 
    for (;;) {
        m = OsNextWork(&code,&dataP,&usrPtr);
	if (m != NULLPTR) {
	    UsrPrg(code,usrPtr,dataP);
	    if (PE(peNum).myChareBlk->chareStat == CHARETYPE_KILL) {
	        QmDeChQ(PE(peNum).myChareBlk,&PE(peNum).allChareQ);
	        OsFree(PE(peNum).myChareBlk,
			sizeof(CHAREBLK)+PE(peNum).myChareBlk->cdataSize);
	        }
	    }
    	}
}

MatchLogicID(x,y)
int x,y;
{
    int a,b,i;
    for (i = 0; i < 4; i++) {
	a = (x >> (i*4)) & 0xF;
	b = (y >> (i*4)) & 0xF;
	if (a <= 9 && b <= 9 && a != b) {
	    return(FALSE);
	    }
	}
    return(TRUE);
}
Os2LogicID(x)
int x;
{   int y=0,z;
    
    z = x/1000;	x -= z*1000;	y += z*4694;
    z = x/100;	x -= z*100;	y += z*256;
    z = x/10;	x -= z*10;	y += z*16;
    y += x;
    return(y);
}
OsIDspread(x1,x2,x3,x4)
int x1,x2,x3,x4;
{   int y=0,z;
    
    return(y);
}
